n=16;

\\------------------------------------------------------
Sd(d,v) = matrix(n,n,x,y,if(x-y==d,v[y],0));
\\    Sd(1,Z(-1)) \\ = lg(P)

\\ Matrix-exponential
MExp(m)= sum(k=1,n,m^(k-1)/(k-1)!) ;
\\   tst=mexp(Sd(1,Z(-1)))  // = P
\\  MExp(matrix(2,2,x,y,x*y))
Pk(k) = MExp(Sd(1,Z(-k)))
    \\   Pk(0)
\\------------


     \\ powerseries
V(b)   = matrix(n,1,x,y,b^(x-1))[,1];     \\ [1, b, b, b ,...]
dV(b) = matdiagonal(V(b));

     \\ Alternating signs
J = V(-1);                                \\ [1, -1, 1, -1, ...]
dJ = matdiagonal(J);


     \\ zeta-series
Z(e)   = matrix(n,1,x,y,x^-e)[,1];        \\ [1, 2^-e, 3^-e, 4^-e, ...]
dZ(e) = matdiagonal(Z(e));

     \\ Summation-utility
Ev = Z(0);                                \\ [1,1,1,1,....] 
dEv = matdiagonal(Ev);

     \\ some variation of Z()
Z_pl(p,e) = matrix(n,1,x,y,(x+p)^-e)[,1]; \\ [(1+p)^-e, (2+p)^-e, ...] 

         \\ Vandermondematrix, where Pj * ZV = Hasse's Euler-Summation
ZV=matrix(n,n,x,y,x^(y-1));               \\ [Z(0), Z(-1), Z(-2),....]



     \\ Factorials and reciprocal factorials
Fac    = matrix(n,1,x,y,(x-1)!)[,1];      \\ [0!, 1!, 2!, ...]
FacInv = matrix(n,1,x,y,1/(x-1)!)[,1];    \\ [1,  ,   1/2,  1/3! ,... ]
dFac(e=0)    = matrix(n,n,x,y,if(x==y,(x-1)!^e,0));      \\ [0!, 1!, 2!, ...]



     \\ Pascal- or binomialmatrix
P = matpascal(n-1);                       \\ [1;  1, 1;  1, 2,1;  1, 3,3, 1;....]
     \\ column-signed binomialmatrix
Pj = P*dJ;                                \\ [1;  1,-1;  1,-2,1;  1,-3,3,-1; ...]
     \\ row-and column-signed binomialmatrix  = P^-1
PInv=dJ*P*dJ;                         \\P^-1 = [1; -1, 1;  1,-2,1; -1, 3,-3,1; ...]

  \\ reciprocal of binom
rbinom(x,y)= if(x<y,0,1/binomial(x,y)) ;
Pjr = matrix(n,n,x,y,rbinom(x,y)) ;


\\ PPOw(s): beliebige Potenz der Pascalmatrix ber Matrixexponential
PPow(s) = MExp(Sd(1,Z(-1)*s));
PkPow(k,s) = MExp(Sd(1,Z(-k)*s));


\\ generische Eigenwertmatrix von Pj
Ewp(v)=matrix(n,n,x,y, if(x<y,0,v[x-y+1]) * binomial(x-1,y-1)/y)
Ewm(v) = dJ*Ewp*dJ


\\ verschiedene Eigenmatrizen von PJ
     \\ Gotti-matrices. Gm has the coefficients of Integrals of Bernoulli-functions
GmInv = vecextract(matpascal(n)-matid(n+1),  concat("2..",n+1),concat("1..",n)) ;     
Gm = GmInv^-1    ;
GpInv = dJ*GmInv * dJ ;
Gp = dJ* Gm*dJ;                                  

   
A=(V(1/2)~*Pj*ZV)~ ;
 \\ Pj*A  \\ = A

Ap = Ewp(A);
Am = dJ * Ap * dJ ;
 \\ P*Am = Ap 

Zp = Ewp(Z(1));
Zm = dJ * Zp * dJ;

Vp = Ewp(V(1/2));
Vm = dJ * Vp * dJ;

\\  Pj * Zp
\\   Pj*Vp - Vp*dJ
Ep=Ewp((V(0)+V(1))/2);
Em = dJ*Ep * dJ;
  \\  P*Em - Ep

     \\ Stirling-kind2
St2=(dFac(-1)*PInv*ZV)~;       \\ Stirling kind 2
St1=St2^-1; 

\\ Delta=dJ*dFac(1)*St2~
Delta=Pj*ZV;

\\  -----------------------------


\\ Printing utilities -----------------------------------------
Pri(m,lae)=  {local(i,j); \
   for(i=1,lae,  \
         [for(j=1,lae,      \
             print1("\"",real(m[i,j]),"\", ",         \
                    "\"",if(imag(m[i,j])>=0,"+",""),imag(m[i,j])," i\", ")       \
             ) ,                                  \
          print(" ")  \
         ])} ;

PriV(m,lae)=  {local(i,j); \
     for(j=1,lae,      \
         print1("\"",real(m[j,1]),"\", ",         \
                "\"",if(imag(m[j,1])>=0,"+",""),imag(m[j,1])," i\", ") \
        );       \
       print(" ")  }  ;

PriReal(m,lae)=  {local(i,j); \
          for(i=1,lae,     \
                [for(j=1,lae-1,      \
                   print1(real(m[i,j]),",")       \
                     )    ,                  \
                 print(real(m[i,lae])),print1(" ")    \
                 ])};

n